#ifndef _checkboard_h
#define _checkboard_h 1

#include <JTC/JTC.h>

class Checkboard : public JTCMonitor {
public:
    Checkboard( int size);
    void entry();
    void printAndCheck();

private:
    int* board_;
    int size_;
};

class CheckboardEntryThread : public JTCThread {

public:
    CheckboardEntryThread( Checkboard* cb_);
    virtual void run();

private:
    Checkboard* cb_;
};

class CheckboardPrinterThread : public JTCThread {

public:
    CheckboardPrinterThread( Checkboard* cb_);
    virtual void run();

private:
    Checkboard* cb_;
};

#endif
